/*
 Daniel L. Rosenband
 MIT / LCS / CSG
*/

module GCDTest (/*AUTOARGS*/);

   reg clk;
   reg rst_n;
   
   reg [31:0] x;
   reg [31:0] y;

   reg start_en;

   wire [31:0] result;
      
   wire start__rdy;
   wire result__rdy;
   
   always #5 clk = ~clk;

   initial
     begin
	$vcdpluson;
	$vcdplustraceon;

	clk = 1'b1;
	rst_n = 1'b1;
	start_en = 1'b0;
	
	pclk;

	rst_n = 1'b0;
	pclks(10);
	rst_n = 1'b1;

	x = 24;
	y = 156;

	PulseStartOnRdy;
	PrintResultOnRdy;

	#100;
		
	$finish;
     end // initial begin

   task pclk;
      begin
	 @(posedge clk);
      end
   endtask // pclk
   
   task pclks;
      input [31:0] num;
      integer i;
      begin
	 for (i = 0; i < num; i = i + 1)
	   pclk;
      end
   endtask // pclks

   task PulseStartOnRdy;
      begin
	 while (!start__rdy)
	   pclk;
	 $display($time, "  Starting to compute GCD of %d and %d.\n", x, y);
	 start_en = 1'b1;
	 pclk;
	 start_en = 1'b0;
      end
   endtask // PulseStartOnRdy

   task PrintResultOnRdy;
      begin
	 pclk;
	 while (!result__rdy)
	   pclk;
	 $display($time, "  Result = %d.\n", result);
      end
   endtask // PrintResultOnRdy

   mkGCD mkGCD (
		// Outputs
		.start__rdy		(start__rdy),
		.result_		(result[31:0]),
		.result__rdy		(result__rdy),
		// Inputs
		.CLK			(clk),
		.RST_N			(rst_n),
		.start__1		(x[31:0]),
		.start__2		(y[31:0]),
		.E_start_		(start_en));

endmodule // MIPSShell
